package net.canreal.canrealsystem.commands;

import net.canreal.canrealsystem.Canrealsystem;
import net.canreal.canrealsystem.systemhandlers.ConfigHandler;
import net.canreal.canrealsystem.systemhandlers.MySQLHandler;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import static org.bukkit.Bukkit.getServer;

public class StatCommand implements CommandExecutor {

    private static MySQLHandler mysqlHandler;
    private static ConfigHandler configHandler;

    @Override
    public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
        mysqlHandler = new MySQLHandler(JavaPlugin.getPlugin(Canrealsystem.class));
        configHandler = new ConfigHandler(JavaPlugin.getPlugin(Canrealsystem.class));
        if (sender instanceof Player) {
             if (args.length == 0) {
                Player p = (Player) sender;
                try {
                    if (isPlayerInDatabase(p)) {
                        try {
                            int kills = getKills(p);
                            int deaths = getDeaths(p);
                            float kd = (float) kills / (float) deaths;
                            String kdString = String.format("%.2f", kd);
                            p.sendMessage("§6Deine Statistiken:");
                            p.sendMessage("§6Kills: §e" + kills);
                            p.sendMessage("§6Tode: §e" + deaths);
                            p.sendMessage("§6K/D: §e" + kdString);
                        } catch (SQLException e) {
                            e.printStackTrace();
                        }
                    } else {
                        p.sendMessage("§cDu hast noch keine Statistiken.");
                    }
                } catch (SQLException e) {
                    throw new RuntimeException(e);
                }
            }
             if (args.length == 1) {
                 // Get player from args
                    Player target = getServer().getPlayer(args[0]);
                    Player p = (Player) sender;
                    if (target != null) {
                        try {
                            if (isPlayerInDatabase(target)) {
                                try {
                                    int kills = getKills(target);
                                    int deaths = getDeaths(target);
                                    float kd = (float) kills / (float) deaths;
                                    String kdString = String.format("%.2f", kd);
                                    p.sendMessage("§6Statistiken von " + target.getName() + ":");
                                    p.sendMessage("§6Kills: §e" + kills);
                                    p.sendMessage("§6Tode: §e" + deaths);
                                    p.sendMessage("§6K/D: §e" + kdString);
                                } catch (SQLException e) {
                                    e.printStackTrace();
                                }
                            } else {
                                p.sendMessage("§cDer Spieler hat noch keine Statistiken.");
                            }
                        } catch (SQLException e) {
                            throw new RuntimeException(e);
                        }
                    } else {
                        p.sendMessage("§cDer Spieler ist nicht online.");
                    }
             }
             if (args.length > 1) {
                 sender.sendMessage("§cBitte benutze /stat [Spieler]");
             }
        }
        return true;
    }


    private boolean isPlayerInDatabase(Player p) throws SQLException {
        configHandler = new ConfigHandler(JavaPlugin.getPlugin(Canrealsystem.class));
        // Get database table name from config
        String tableName = configHandler.getString("database.mysql.tableNamePVPKills");
        return mysqlHandler.getConnection().prepareStatement("SELECT * FROM " + tableName + " WHERE player_uuid = '" + p.getUniqueId() + "'").executeQuery().next();
    }

    private int getKills(Player p) throws SQLException {
        configHandler = new ConfigHandler(JavaPlugin.getPlugin(Canrealsystem.class));
        // Get database table name from config
        String tableName = configHandler.getString("database.mysql.tableNamePVPKills");

        PreparedStatement ps = mysqlHandler.getConnection().prepareStatement("SELECT kill_count FROM " + tableName + " WHERE player_uuid = '" + p.getUniqueId() + "'");
        ResultSet rs = ps.executeQuery();
        rs.next();
        return rs.getInt("kill_count");
    }

    private int getDeaths(Player p) throws SQLException {
        configHandler = new ConfigHandler(JavaPlugin.getPlugin(Canrealsystem.class));
        // Get database table name from config
        String tableName = configHandler.getString("database.mysql.tableNamePVPKills");

        PreparedStatement ps = mysqlHandler.getConnection().prepareStatement("SELECT killed_count FROM " + tableName + " WHERE player_uuid = '" + p.getUniqueId() + "'");
        ResultSet rs = ps.executeQuery();
        rs.next();
        return rs.getInt("killed_count");
    }
}
