package net.canreal.canrealsystem.commands;

import net.canreal.canrealsystem.Canrealsystem;
import net.canreal.canrealsystem.systemhandlers.ConfigHandler;
import net.canreal.canrealsystem.systemhandlers.MySQLHandler;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class TopCommand implements CommandExecutor {
    private static MySQLHandler mysqlHandler;
    private static ConfigHandler configHandler;

    @Override
    public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
        mysqlHandler = new MySQLHandler(JavaPlugin.getPlugin(Canrealsystem.class));
        configHandler = new ConfigHandler(JavaPlugin.getPlugin(Canrealsystem.class));

        if (!(sender instanceof Player)) {
            sender.sendMessage("§cDieser Befehl kann nur ingame verwendet werden.");
            return true;
        }

        if (args.length == 0) {
            sender.sendMessage("§cBitte gib an, nach welcher Statistik du sortieren möchtest. (/top <kills/deaths>");
        }
        if (args.length == 1) {
            if (args[0].equalsIgnoreCase("kills")) {
                sender.sendMessage("§6Top 10 Kills:");
                getTopKills((Player) sender);
            }
            if (args[0].equalsIgnoreCase("deaths")) {
                sender.sendMessage("§6Top 10 Tode:");
                getTopDeaths((Player) sender);
            }
        }
        return true;
    }

    // Function to get top 10 players with most kills from database and send them to player
    public void getTopKills(Player p) {
        mysqlHandler = new MySQLHandler(JavaPlugin.getPlugin(Canrealsystem.class));
        configHandler = new ConfigHandler(JavaPlugin.getPlugin(Canrealsystem.class));

        String tableName = configHandler.getString("database.mysql.tableNamePVPKills");

        String query = "SELECT * FROM " + tableName + " ORDER BY kill_count DESC LIMIT 10";
        try {
            PreparedStatement preparedStatement = mysqlHandler.getConnection().prepareStatement(query);
            ResultSet resultSet = preparedStatement.executeQuery();
            while (resultSet.next()) {
                String playerName = resultSet.getString("player_name");
                int kills = resultSet.getInt("kill_count");
                p.sendMessage("§6" + playerName + ": §e" + kills);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
    }

    // Function to get top 10 players with most deaths from database and send them to player
    public void getTopDeaths(Player p) {
        mysqlHandler = new MySQLHandler(JavaPlugin.getPlugin(Canrealsystem.class));
        configHandler = new ConfigHandler(JavaPlugin.getPlugin(Canrealsystem.class));

        String tableName = configHandler.getString("database.mysql.tableNamePVPKills");

        String query = "SELECT * FROM " + tableName + " ORDER BY killed_count DESC LIMIT 10";
        try {
            PreparedStatement preparedStatement = mysqlHandler.getConnection().prepareStatement(query);
            ResultSet resultSet = preparedStatement.executeQuery();
            while (resultSet.next()) {
                String playerName = resultSet.getString("player_name");
                int deaths = resultSet.getInt("killed_count");
                p.sendMessage("§6" + playerName + ": §e" + deaths);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
    }
}
