package net.canreal.canrealsystem.events;

import net.canreal.canrealsystem.Canrealsystem;
import net.canreal.canrealsystem.systemhandlers.ConfigHandler;
import net.canreal.canrealsystem.systemhandlers.MySQLHandler;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.PlayerDeathEvent;
import org.bukkit.plugin.java.JavaPlugin;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class PlayerKillEvent implements Listener {
    private static MySQLHandler mysqlHandler;
    private static ConfigHandler configHandler;

    @EventHandler
    public void onPlayerKill(PlayerDeathEvent e) throws SQLException {
        Canrealsystem canrealsystem = JavaPlugin.getPlugin(Canrealsystem.class);
        mysqlHandler = new MySQLHandler(canrealsystem);
        configHandler = new ConfigHandler(canrealsystem);
        Player p = e.getPlayer();
        if (p.getKiller() instanceof Player) {
            Player killer = p.getKiller();
            killer.sendMessage("§aDu hast §6" + p.getName() + " §aerledigt!");
            // Get database table name from config
            String tableName = configHandler.getString("database.mysql.tableNamePVPKills");
            if (isPlayerInDatabase(killer)) {
                // Count up the kill count and update the player name in the database
                mysqlHandler.getConnection().prepareStatement("UPDATE " + tableName + " SET kill_count = kill_count + 1, player_name = '" + killer.getName() + "' WHERE player_uuid = '" + killer.getUniqueId() + "'").executeUpdate();
                int kills = getKills(killer);
                killer.sendMessage("§aDu hast nun insgesamt §6" + kills + " §aSpieler erledigt!");

            } else {
                mysqlHandler.getConnection().prepareStatement("INSERT INTO " + tableName + " (player_uuid, player_name, kill_count, killed_count) VALUES ('" + killer.getUniqueId() + "', '" + killer.getName() + "', 1, 0)").executeUpdate();
                int kills = getKills(killer);
                killer.sendMessage("§aDu hast nun insgesamt §6" + kills + " §aSpieler erledigt!");
            }

            if (isPlayerInDatabase(p)) {
                // Count up the death count and update the player name in the database
                mysqlHandler.getConnection().prepareStatement("UPDATE " + tableName + " SET killed_count = killed_count + 1, player_name = '" + p.getName() + "' WHERE player_uuid = '" + p.getUniqueId() + "'").executeUpdate();
                int deaths_player = getDeaths(p);
                p.sendMessage("§cDu wurdest von §6" + killer.getName() + " §cerledigt! Du hast nun insgesamt §6" + deaths_player + " §cTode!");

            } else {
                mysqlHandler.getConnection().prepareStatement("INSERT INTO " + tableName + " (player_uuid, player_name, kill_count, killed_count) VALUES ('" + p.getUniqueId() + "', '" + p.getName() + "', 0, 1)").executeUpdate();
                int deaths_player = getDeaths(p);
                p.sendMessage("§cDu wurdest von §6" + killer.getName() + " §cerledigt! Du hast nun insgesamt §6" + deaths_player + " §cTode!");
            }
        }
    }

    private boolean isPlayerInDatabase(Player p) throws SQLException {
        configHandler = new ConfigHandler(JavaPlugin.getPlugin(Canrealsystem.class));
        // Get database table name from config
        String tableName = configHandler.getString("database.mysql.tableNamePVPKills");
        return mysqlHandler.getConnection().prepareStatement("SELECT * FROM " + tableName + " WHERE player_uuid = '" + p.getUniqueId() + "'").executeQuery().next();
    }

    private int getKills(Player p) throws SQLException {
        configHandler = new ConfigHandler(JavaPlugin.getPlugin(Canrealsystem.class));
        // Get database table name from config
        String tableName = configHandler.getString("database.mysql.tableNamePVPKills");

        PreparedStatement ps = mysqlHandler.getConnection().prepareStatement("SELECT kill_count FROM " + tableName + " WHERE player_uuid = '" + p.getUniqueId() + "'");
        ResultSet rs = ps.executeQuery();
        rs.next();
        return rs.getInt("kill_count");
    }

    private int getDeaths(Player p) throws SQLException {
        configHandler = new ConfigHandler(JavaPlugin.getPlugin(Canrealsystem.class));
        // Get database table name from config
        String tableName = configHandler.getString("database.mysql.tableNamePVPKills");

        PreparedStatement ps = mysqlHandler.getConnection().prepareStatement("SELECT killed_count FROM " + tableName + " WHERE player_uuid = '" + p.getUniqueId() + "'");
        ResultSet rs = ps.executeQuery();
        rs.next();
        return rs.getInt("killed_count");
    }
}
