package net.canreal.canrealsystem.systemhandlers;

import net.canreal.canrealsystem.Canrealsystem;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

public class MySQLHandler {
    private Connection conn;
    private final Canrealsystem canrealsystem;


    public MySQLHandler(Canrealsystem canrealsystem) {
        this.canrealsystem = canrealsystem;
        ConnectToDatabase();
    }

    public void ConnectToDatabase() {
        String host = canrealsystem.getConfigHandler().getString("database.mysql.host");
        String port = canrealsystem.getConfigHandler().getString("database.mysql.port");
        String database = canrealsystem.getConfigHandler().getString("database.mysql.databaseName");
        String user = canrealsystem.getConfigHandler().getString("database.mysql.user");
        String password = canrealsystem.getConfigHandler().getString("database.mysql.password");

        try {
            // Load the driver
            Class.forName("com.mysql.jdbc.Driver");
            // Connect to database
            System.out.println("Connection String: " + "jdbc:mysql://" + host + ":" + port + "/" + database + "?autoReconnect=true");
            System.out.println("User: " + user);
            System.out.println("Password: " + password);
            conn = DriverManager.getConnection("jdbc:mysql://" + host + ":" + port + "/" + database + "?autoReconnect=true", user, password);
        } catch (SQLException e) {
            e.printStackTrace();
            System.out.println("Verbindung zur MySQL Datenbank konnte nicht hergestellt werden!");
        } catch (ClassNotFoundException e) {
            throw new RuntimeException(e);
        }
    }

    public void DisconnectFromDatabase() {
        try {
            // No need to close the connection if it is already closed
            if (this.IsConnectedToDatabase()) {
                this.conn.close();
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    public boolean IsConnectedToDatabase() {
        return this.conn != null;
    }

    public Connection getConnection() {
        return this.conn;
    }
}